from collections import namedtuple

# Nossa maquina por enquanto tem apenas
# memoria, posição atual de leitura
# status atual, valor de entrada do usuario
# e saída atual
Maquina = namedtuple("Maquina", "memoria pos status entrada saida")

# Os Status podem ser:
# IDLE: aguardando execução
# WAIT: esperando por entrada de dados (não utilizado no momento)
# HALT: terminou execução
IDLE =  0
WAIT =  1
HALT = -1

# Cria uma máquina a partir de uma lista com um estado de memória
def criaMaquina(xs : [int]) -> Maquina:
    return Maquina(xs.copy(), 0, IDLE, None, None)

''' Exercício 01
    Crie as funções opcode e pegaModoN
    
    A função opcode recebe um inteiro contendo um código de operação
    e retorna os dois últimos digitos dele.
    
    A função pegaModoN recebe um valor x e um número n e devolve
    o n-ésimo dígito contando da direita para a esquerda.
    
    Ex.: pegaModoN(123, 1) deve retornar 3
         pegaModoN(123, 2) deve retornar 2
         pegaModoN(123, 3) deve retornar 1
'''
def opcode(x : int) -> int:
    pass # substitua essa linha pelo seu código
    
def pegaModoN(x : int, n : int) -> int:
    pass # substitua essa linha pelo seu código
    
# Lê o argumento n utilizando o modo de posição mode
# Se modo == 0 retorna memoria[memoria[pos+n]]
# Se modo == 1 retorna memoria[pos+n]
def leiaArgN(m : Maquina, n : int, mode : int) -> int:
    k = m.memoria[m.pos + n]
    
    if   mode == 0:
        if k < len(m.memoria):
            return m.memoria[k]
        else:
            return 0
    elif mode == 1:
        return k

# Lê o argumento de escrita, sempre opera no modo 1
def leiaPosEscrita(m : Maquina, n : int, mode : int) -> int:
    return m.memoria[m.pos + n]
                 
def somar(m : Maquina) -> Maquina:
    memoria, pos, status, entrada, saida = m
    
    modes = memoria[pos]//100
    mode1 = pegaModoN(modes,1)
    mode2 = pegaModoN(modes,2)
    mode3 = pegaModoN(modes,3)
    
    x = leiaArgN(m, 1, mode1)
    y = leiaArgN(m, 2, mode2)
    z = leiaPosEscrita(m, 3, mode3)
    
    memoria[z] = x + y
    pos        = pos + 4
    
    return Maquina(memoria, pos, status, entrada, saida)
    
def multiplicar(m : Maquina) -> Maquina:
    memoria, pos, status, entrada, saida = m
    
    modes = memoria[pos]//100
    mode1 = pegaModoN(modes,1)
    mode2 = pegaModoN(modes,2)
    mode3 = pegaModoN(modes,3)
    
    x = leiaArgN(m, 1, mode1)
    y = leiaArgN(m, 2, mode2)
    z = leiaPosEscrita(m, 3, mode3)
    
    memoria[z] = x * y
    pos        = pos + 4
    
    return Maquina(memoria, pos, status, entrada, saida)
    
''' Exercício 02:
Escreva as funções ler e escrever.
A função ler deve ler o próximo argumento da memória (usando leiaPosEscrita)
colocar o valor de entrada nessa posição, substituindo entrada por None na sequência
Não esqueça de mover a posição atual do ponteiro em duas posições.

A função escrever deve ler o próximo argumento da memória (usando leiaArgN)
e colocar esse valor no campo saida de sua máquina.
'''    
def ler(m : Maquina) -> Maquina:
    memoria, pos, status, entrada, saida = m
    
    ''' ESCREVA SEU CÓDIGO ABAIXO '''
    
    
    
    
    ''' FIM DO EXERCÍCIO          '''
    
    return Maquina(memoria, pos, status, entrada, saida)
    
def escrever(m : Maquina) -> Maquina:
    memoria, pos, status, entrada, saida = m
    
    ''' ESCREVA SEU CÓDIGO ABAIXO '''
    
    
    
    
    ''' FIM DO EXERCÍCIO          '''
    
    return Maquina(memoria, pos, status, entrada, saida)

''' Exercício 03:
Escreva as funções pularNZ e pularZ
A função pularNZ deve ler dois argumentos de entrada (usando leiaArgN)
e, se o  primeiro argumento for diferente de zero, atualize pos para o valor
do segundo argumento, caso contrário atualize pos para 3 posições a frente.

A função pularZ é análoga  apenas trocando a comparação pela igualdade a zero.
'''    
def pularNZ(m : Maquina) ->  Maquina:
    memoria, pos, status, entrada, saida = m
    
    ''' ESCREVA SEU CÓDIGO ABAIXO '''
    
    
    
    
    ''' FIM DO EXERCÍCIO          '''

    return Maquina(memoria, pos, status, entrada, saida)

def pularZ(m : Maquina) ->  Maquina:
    memoria, pos, status, entrada, saida = m
    
    ''' ESCREVA SEU CÓDIGO ABAIXO '''
    
    
    
    
    ''' FIM DO EXERCÍCIO          '''

    return Maquina(memoria, pos, status, entrada, saida)

''' Exercício 04:
Escreva as funções comparar e igual
A função comparar deve ler dois argumentos de entrada (usando leiaArgN)
e a posição de escrita (usando leiaPosEscrita).
Se o primeiro argumento for menor que o segundo, escreva 1 na posição de escrita
caso contrário escreva 0.

A função igual é análoga  apenas trocando a comparação por igualdade.
'''     
def comparar(m : Maquina) -> Maquina:
    memoria, pos, status, entrada, saida = m
    
    ''' ESCREVA SEU CÓDIGO ABAIXO '''
    
    
    
    
    ''' FIM DO EXERCÍCIO          '''
    
    return Maquina(memoria, pos, status, entrada, saida)

def igual(m : Maquina) -> Maquina:
    memoria, pos, status, entrada, saida = m
    
    ''' ESCREVA SEU CÓDIGO ABAIXO '''
    
    
    
    
    ''' FIM DO EXERCÍCIO          '''
    
    return Maquina(memoria, pos, status, entrada, saida)
        
# Termina a execução da máquina alterando seu status para HALT
def terminar(m : Maquina) -> Maquina:
    memoria, pos, status, entrada, saida = m
    
    return Maquina(memoria, pos, HALT, entrada, saida)   
                
# Executa a próxima operação da máquina
def step(m : Maquina) -> Maquina:
    
    # pega o código de operação
    op = opcode(m.memoria[m.pos])
    
    # executa a função correspondente
    if   op == 1:
        return somar(m)
    elif op == 2:
        return multiplicar(m)

    # Descomente as linhas abaixo conforme terminar cada exercício!
    #elif op == 3:
    #    return ler(m)
    #elif op == 4:
    #    return escrever(m) 
    #elif op == 5:
    #    return pularNZ(m)
    #elif op == 6:
    #    return pularZ(m)
    #elif op == 7:
    #    return comparar(m)
    #elif op == 8:
    #    return igual(m)              
    elif op == 99:
        return terminar(m)
    return m

# executa a máquina até que, ou ela termine, ou ela aguarde por nova entrada
def executa(m : Maquina, entrada : int) -> (Maquina, [int]):
    # O símbolo _ significa que não queremos guardar a entrada atual
    memoria, pos, status, _, saida = m
    m = Maquina(memoria, pos, IDLE, entrada, saida)
    
    # armazena as saídas obtidas em uma lista
    saidas = []  
    
    # enquanto não é interrompida
    while m.status != WAIT and m.status != HALT:
        # executa a máquina
        m = step(m)
        
        # se tiver alguma saída, guarda na lista
        if m.saida is not None:
            saidas.append(m.saida)
            m = m._replace(saida=None)
        
    return (m, saidas)

# lê um arquivo de entrada
def leiaArquivo(nome : str) -> [int]:
    with open(nome) as f:
        return list(map(int, f.readlines()[0].split(",")))    
    

